<script lang="ts" setup>
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useRoleStore } from '@/stores/role'
import type { Role } from '@/types/Role'

const roleStore = useRoleStore()

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Role',
    key: 'name',
    value: 'name'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)

function onSubmit() {}
onMounted(async () => {
  await roleStore.getRoles()
})
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    roleStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await roleStore.deleteRole()
  closeDelete()
}
async function editItem(item: Role) {
  if (!item.id) return
  await roleStore.getRole(item.id)
  dialog.value = true
}
async function deleteItem(item: Role) {
  if (!item.id) return
  await roleStore.getRole(item.id)
  dialogDelete.value = true
}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    roleStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await roleStore.saveRole()
  closeDialog()
}
</script>

<template>
  <v-data-table-virtual
    :headers="headers"
    :items="roleStore.roles"
    :sort-by="[{ key: 'calories', order: 'asc' }]"
    fixed-header
  >
    <template v-slot:top>
      <v-toolbar flat>
        <v-toolbar-title>My CRUD</v-toolbar-title>
        <v-divider class="mx-4" inset vertical></v-divider>
        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="500px">
          <template v-slot:activator="{ props }">
            <v-btn class="mb-2" color="primary" dark v-bind="props"> New Item </v-btn>
          </template>
          <v-card>
            <v-card-title>
              <span class="text-h5"> CRUD ROLE </span>
            </v-card-title>

            <v-card-text>
              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-container>
                  <v-row>
                    <v-col cols="12" md="4" sm="6">
                      <v-text-field
                        v-model="roleStore.editedRole.name"
                        label="Set Role Title"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-form>
            </v-card-text>

            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Cancel </v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
              <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon class="me-2" size="small" @click="editItem(item)"> mdi-pencil </v-icon>
      <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn color="primary" @click="roleStore.getRoles"> Reset </v-btn>
    </template>
  </v-data-table-virtual>
</template>
